use crate::MainWindow;
use super::{GUIElements, GUIElementsRef, MainWindowRef};
use slint::Image;

pub struct FileTab {
    main_window: MainWindowRef
}

impl FileTab {
    pub fn new(main_window: MainWindowRef) -> FileTab {
        FileTab{main_window}
    }

    pub fn update_new_load(&self, file_name: Option<String>, image: Image) {
        self.main_window.borrow().set_file_tab_image_data(image);
        if let Some(file_name) = file_name {
            self.main_window.borrow().set_file_tab_image_name(file_name.into());
        }
        
        else {
            self.main_window.borrow().set_file_tab_image_name("".into());
        }
    }

    pub fn on_browse_file(&self, gui_elements: GUIElementsRef, mut function: impl FnMut(&mut GUIElements, &MainWindow) + 'static) {
        let main_window_cloned = self.main_window.clone();
        let gui_cloned         = gui_elements.clone();

        self.main_window.borrow().on_file_tab_browse_convert_image(move || {
            function(&mut gui_cloned.borrow_mut(), &main_window_cloned.borrow());
        });
    }
}